// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: Frame
// Author: Hassan Siddiqui
//
// Description: 
// Models incident photon distribution on detector.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: Frame.h,v 1.1 1999/02/04 16:13:39 hsiddiqu Exp $

#ifndef Frame_H
#define Frame_H

// General classes

#include <math.h>

// SAS-specific classes

#include "Dal.h"

// Utility functions
#include "Tracer.h"

// Local functions
#include "PhotonDistribution.h"

// ========================================================================

// class Frame

// Encapsulates frame period and methods related to frame period.

// Created specifically generate flux/frame values from 
// PhotonDistribution objects while avoiding large inheritance tree resulting 
// from subclassing PhotonDistribution.

// ========================================================================


class Frame
{

public:

  /* Constructor */

  Frame(const PhotonDistribution * photonDistribution):
    _photondist(photonDistribution)
    {};
  
  /* Determine flux (/frame) for given energy */
  double frameFlux(double framePeriod,
		   double energy ) const
    {
      PROC;
      assert(_photondist);
      RETURN  _photondist->flux(energy) * framePeriod;
    }

private:

  const PhotonDistribution *   _photondist;

};
#endif




