// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: Interpolator
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: Interpolator.cc,v 1.1 2000/03/28 12:42:50 hsiddiqu Exp $

/* General */

/* Sas-Specific */
#include "Tracer.h"

/* Local */
#include "Interpolator.h"
#include "NumericalRange.h"

/* Interpolate data of type double */
double Interpolator::calc ( double xMean,
			    double xLow, 
			    double xHigh, 
			    double yLow, 
			    double yHigh )
{
  PROC;

  //       cout << " double calc : " << endl
  // 	   << " xMean "  << xMean  << " "
  // 	   << " xLow  "  << xLow   << " "
  // 	   << " xHigh "  << xHigh  << endl
  // 	   << " yLow  "  << yLow   << endl
  // 	   << " yHigh "  << yHigh  << endl;

  double xdiff = (xHigh-xLow);
  assert (fabs(xdiff) > FLT64_MIN);
  //       cout << " result " <<  yLow + ((xMean-xLow)*(yHigh - yLow)/xdiff) 
  // 	   << endl;
  RETURN yLow + ((xMean-xLow)*(yHigh - yLow)/xdiff);
}

/* Interpolate data of type vector<double> */
vector<double> Interpolator::calc ( double xMean,
				    double xLow, 
				    double xHigh, 
				    vector<double> yLow, 
				    vector<double> yHigh )
{
  PROC;
  
  //       cout << " vector<double> calc : " <<endl
  // 	   << " xMean "  << xMean  << " "
  // 	   << " xLow  "  << xLow   << " "
  // 	   << " xHigh "  << xHigh  << endl
  // 	   << " yLow  "  << yLow   << endl
  // 	   << " yHigh "  << yHigh  << endl;
  
  /* Check that sizes are the same */
  assert ( yLow .size() == yHigh.size());


  /* Generate result */
  vector<double> result;

  for (unsigned int i = 0; i < yLow.size(); ++i )
    {
      result.push_back( calc( xMean,
			      xLow,
			      xHigh,
			      yLow[i],
			      yHigh[i]) );
    }
  
  RETURN result;
}



