// 
// Module: MOSBiPixelPatternFuncs
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: MOSBiPixelPatternFuncs.h,v 1.1 2000/03/28 12:42:51 hsiddiqu Exp $

#ifndef MOSBiPixelPatternFuncs_H
#define MOSBiPixelPatternFuncs_H

/* General classes */
#include <math.h>

/* SAS-specific */
#include "Dal.h"
#include "Tracer.h"

/* Local classes */
#include "SplitPatternFuncs.h"
#include "SplitEventsData.h"


// ==================================================================

// class MOSBiPixelPatternFuncs

// Contains algorithms to correct for pile-up where the pattern of interest
// is of Bi-pixel type.

// ==================================================================

class MOSBiPixelPatternFuncs : public SplitPatternFuncs
{
public:
  
  /* Constructors */
  MOSBiPixelPatternFuncs(const SplitEventsData & splitEventsData);

  ~MOSBiPixelPatternFuncs();

protected:

  /* Note flux is in units of /frame/pixel */

  const PileupData getPileup( const SplitEventsDist& alpha,
			       double flux )  const;

};
#endif
