// 
// Module: MOSQuadPixelPatternFuncs
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: MOSQuadPixelPatternFuncs.h,v 1.1 2000/03/28 12:42:52 hsiddiqu Exp $

#ifndef MOSQuadPixelPatternFuncs_H
#define MOSQuadPixelPatternFuncs_H

/* General classes */
#include <math.h>

/* SAS-specific */

/* Local classes */
#include "SplitPatternFuncs.h"
#include "SplitEventsData.h"


// ==================================================================

// class MOSQuadPixelPatternFuncs

// Contains algorithms to correct for pile-up where the pattern of interest
// is of Quad-pixel type.

// ==================================================================

class MOSQuadPixelPatternFuncs : public SplitPatternFuncs
{
public:
  
  /* Constructors */
  MOSQuadPixelPatternFuncs(const SplitEventsData & splitEventsData);

  ~MOSQuadPixelPatternFuncs();

protected:

  /* Note flux is in units of /frame/pixel */

  const PileupData getPileup( const SplitEventsDist& alpha,
			       double flux )  const;

};
#endif
