// 
// Module: MOSTriPixelPatternFuncs
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: MOSTriPixelPatternFuncs.h,v 1.1 2000/03/28 12:42:53 hsiddiqu Exp $

#ifndef MOSTriPixelPatternFuncs_H
#define MOSTriPixelPatternFuncs_H

/* General classes */
#include <math.h>

/* SAS-specific */

/* Local classes */
#include "SplitPatternFuncs.h"
#include "SplitEventsData.h"


// =================================================================

// class MOSTriPixelPatternFuncs

// Contains algorithms to correct for pile-up where the pattern of interest
// is of Tri-pixel type.

// ==================================================================

class MOSTriPixelPatternFuncs : public SplitPatternFuncs
{
public:
  
  /* Constructors */
  MOSTriPixelPatternFuncs(const SplitEventsData & splitEventsData);

  ~MOSTriPixelPatternFuncs();

protected:

  /* Note flux is in units of /frame/pixel */
  const PileupData getPileup( const SplitEventsDist& alpha,
			       double flux )  const;

};
#endif
