// Module: NonUnifBinnedAxis.h
// Author: Hassan Siddiqui
//
// Description:
//
// A BinnedAxis implementaton that uses an IntervalVector as input 
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: NonUnifBinnedAxis.h,v 1.1 2000/03/28 12:42:53 hsiddiqu Exp $

#ifndef NonUnifBinnedAxis_H
#define NonUnifBinnedAxis_H


/* General classes */
#include <vector>

/* SAS-specific classes */
#include "CalCommon.h"

/* Local classes */

/***********************************************************
 *
 * class NonUnifBinnedAxis
 *
 ***********************************************************/

class NonUnifBinnedAxis : public BinnedAxis {
public:

  /* Construct from an InternalVector object */
  NonUnifBinnedAxis (const IntervalVector<double> & in);

  /* Construct from a previous BinnedAxis object (eg a reference) */
  NonUnifBinnedAxis (const BinnedAxis & in);

  unsigned bins() const;

  Bin bin(unsigned index = 0) const;

  Bin bin(double value) const;

  unsigned index(double value) const;

  unsigned & operator[](unsigned index);

  unsigned & operator[](double value);

  ~NonUnifBinnedAxis();


private:

  IntervalVector<double> _intervalVector;
  unsigned _bins;
};

#endif




