// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: NullPhotonDistribution
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: NullPhotonDistribution.h,v 1.3 2000/05/25 11:19:49 hsiddiqu Exp $

#ifndef NullPhotonDistribution_H
#define NullPhotonDistribution_H

// General classes

#include <string>
#include <iostream.h>
#include <vector>
#include <math.h>

// SAS-specific classes

#include "Dal.h"
#include "errstr.h"

// Utility functions
#include "Tracer.h"

// Local functions
#include "PhotonDistribution.h"
#include "InterpolatedData.h"

// ========================================================================

// class NullPhotonDistribution

// A null representation of a photondistribution class. It raises an error if the key method, flux() is used.

// ========================================================================

class NullPhotonDistribution : public PhotonDistribution
{

public:

  /* Constructor */
  NullPhotonDistribution()   {};

  /* Determine flux (photons/s) for given energy */
  double flux( double /* energy */ ) const
    {
      PROC;
      
//        errstr << " NullPhotonDistribution model being used." 
//  	     << Sas::message(Msg::App,Msg::Verbose);

      RETURN 0;
    }

  /* Destructor */
  ~NullPhotonDistribution(){};

private:

};
#endif




