// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: PhotonDistribution
// Author: Hassan Siddiqui
//
// Description: 
// Models incident photon distribution on detector.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: PhotonDistribution.h,v 1.2 1999/02/08 12:17:17 hsiddiqu Exp $

#ifndef PhotonDistribution_H
#define PhotonDistribution_H

// General classes

#include <string>
#include <iostream.h>
#include <vector>
#include <math.h>

// SAS-specific classes

#include "Dal.h"

// Utility functions
#include "Tracer.h"

// Local functions

// ========================================================================

// class PhotonDistribution

// Abstract class that models incident photon distribution on detector.

// ========================================================================


class PhotonDistribution
{

public:

  /* Constructor */
  PhotonDistribution(){};

  /* Determine flux (/s) for given energy */
  virtual double flux(double energy ) const = 0;
  

  /* Determine probability of photon hitting detector using input spectrum */
  const double probability(double energy ) const  
    {
      PROC; 
      RETURN poisson1(flux(energy));
    }

  virtual ~PhotonDistribution() {};

private:

  /* Calculate probability of a single event occuring */
  inline double poisson1(double avg_events) const
    {
      PROC;
      RETURN avg_events * exp((-1) * avg_events);
    }

  /* Calculate probability of two events occuring */
  inline double poisson2(double avg_events) const
    {
      PROC;
      RETURN 0.5 * avg_events * avg_events * exp((-1) * avg_events);
    }
  
};
#endif




